//+------------------------------------------------------------------+
//|                                            Mehanizator_Trall.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

extern int     Magic = 5777;
extern double lot=0.1; 
extern int Deviation=1;      //  
extern double s_los=100;      //  .      .
extern double t_profit=200;   // .............     .

extern string  __________ = "===    ====";
extern bool      UseTrailing = false;//  
extern int    MinProfit = 18;//   
extern int    TrailingStop = 25;//   
extern int    TrailingStep = 1; //   


int tip;
int tiket;
int init()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 if (UseTrailing) TrailPositions(); //    
  
  

if (!OrderSelect(0,SELECT_BY_POS, MODE_TRADES)) tip=3;
 
if (!OrderSelect(0,SELECT_BY_POS, MODE_TRADES)  && iAO(NULL ,0,1)>iAO(NULL ,0,2))
 {
    tiket=OrderSend(Symbol(),OP_BUY,lot,NormalizeDouble(Ask,Digits),Deviation,Bid-s_los*Point,Bid+t_profit*Point," !",Magic);   // Long                                                                                                                             //  
    tip=0;                                               
  }

  
if (!OrderSelect(0,SELECT_BY_POS, MODE_TRADES)  && iAO(NULL ,0,1)<iAO(NULL ,0,2))
 {
    tiket=OrderSend(Symbol(),OP_SELL,lot,NormalizeDouble(Ask,Digits),Deviation,Bid+s_los*Point,Bid-t_profit*Point," !",Magic);   //  Short                                                                                                                             //  
    tip=1;                                               
  }
   
 
   return(0);
  }
//+------------------------------------------------------------------+

//
void TrailPositions() //   
{
  int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;
     if (OrderMagicNumber() == Magic ){    
    if (OrderType() == OP_BUY )  {
     if (Bid-OrderOpenPrice() > MinProfit*Point) {
        if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingStop*Point,
                                                    OrderTakeProfit(), 0, Blue);
        }      }    }
    if (OrderType() == OP_SELL)  {
      if (OrderOpenPrice()-Ask >MinProfit*Point) {
        if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1)*Point 
                                                       || OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingStop*Point,
                                                      OrderTakeProfit(), 0, Blue);
        }   }   }    }   }  }

//+

